scala.tools.nsc.ast.TreeDSL.CODE

# TreeMethods

###
Related Doc: package CODE

#### class TreeMethods extends AnyRef

Source
  TreeDSL.scala

Linear Supertypes
AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. TreeMethods
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new TreeMethods(target: Global.Tree)

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from TreeMethods to any2stringadd[TreeMethods] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (TreeMethods, B)

   Implicit information
     This member is added by an implicit conversion from TreeMethods to ArrowAssoc[TreeMethods] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### def ===(rhs: Global.Tree): Global.Assign

   Assignment

7. #### def AND(other: Global.Tree): Global.Tree

8. #### def ANY_!=(other: Global.Tree): Global.Apply

9. #### def ANY_==(other: Global.Tree): Global.Apply

10. #### def ANY_EQ(other: Global.Tree): Global.Apply

11. #### def APPLY(params: List[Global.Tree]): Global.Apply

12. #### def APPLY(params: Global.Tree*): Global.Apply

    Apply, Select, Match *

13. #### def AS(tpe: Global.Type): Global.Tree

    Casting & type tests -- working our way toward understanding exactly what differs between the different forms of IS and AS.

    Casting & type tests -- working our way toward understanding exactly what differs between the different forms of IS and AS.

    See ticket #2168 for one illustration of AS vs. AS_ANY.

14. #### def DOT(sym: Global.Symbol): SelectStart

15. #### def DOT(member: Global.Name): SelectStart

16. #### def GEN_!=(other: Global.Tree, kind: Global.ClassSymbol): Global.Apply

17. #### def GEN_&(other: Global.Tree, kind: Global.ClassSymbol): Global.Apply

18. #### def GEN_==(other: Global.Tree, kind: Global.ClassSymbol): Global.Apply

19. #### def GEN_|(other: Global.Tree, kind: Global.ClassSymbol): Global.Apply

20. #### def GETCLASS(): Global.Apply

21. #### def INT_-(other: Global.Tree): Global.Apply

22. #### def INT_==(other: Global.Tree): Global.Apply

23. #### def INT_>=(other: Global.Tree): Global.Apply

24. #### def IS_OBJ(tpe: Global.Type): Global.Tree

25. #### def MEMBER_==(other: Global.Tree): Global.Apply

    Note - calling ANY_== in the matcher caused primitives to get boxed for the comparison, whereas looking up nme.EQ does not.

    Note - calling ANY_== in the matcher caused primitives to get boxed for the comparison, whereas looking up nme.EQ does not. See #3570 for an example of how target.tpe can be non-null, yet it claims not to have a member called nme.EQ. Not sure if that should happen, but we can be robust by dragging in Any regardless.

26. #### def OBJ_EQ(other: Global.Tree): Global.Apply

27. #### def OBJ_NE(other: Global.Tree): Global.Apply

28. #### def OR(other: Global.Tree): Global.Tree

    logical/comparison ops *

29. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

30. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

31. #### def ensuring(cond: (TreeMethods) ⇒ Boolean, msg: ⇒ Any): TreeMethods

    Implicit information
      This member is added by an implicit conversion from TreeMethods to Ensuring[TreeMethods] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

32. #### def ensuring(cond: (TreeMethods) ⇒ Boolean): TreeMethods

    Implicit information
      This member is added by an implicit conversion from TreeMethods to Ensuring[TreeMethods] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

33. #### def ensuring(cond: Boolean, msg: ⇒ Any): TreeMethods

    Implicit information
      This member is added by an implicit conversion from TreeMethods to Ensuring[TreeMethods] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

34. #### def ensuring(cond: Boolean): TreeMethods

    Implicit information
      This member is added by an implicit conversion from TreeMethods to Ensuring[TreeMethods] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

35. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

36. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

37. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

38. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from TreeMethods to StringFormat[TreeMethods] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

39. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

40. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

41. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

42. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

43. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

44. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

45. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

46. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

47. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

48. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

49. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

50. #### def →[B](y: B): (TreeMethods, B)

    Implicit information
      This member is added by an implicit conversion from TreeMethods to ArrowAssoc[TreeMethods] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from TreeMethods to any2stringadd[TreeMethods]

### Inherited by implicit conversion StringFormat from TreeMethods to StringFormat[TreeMethods]

### Inherited by implicit conversion Ensuring from TreeMethods to Ensuring[TreeMethods]

### Inherited by implicit conversion ArrowAssoc from TreeMethods to ArrowAssoc[TreeMethods]

### Ungrouped